#ifndef NODE_HPP
#define NODE_HPP

template <typename T>
class CNode
{
private:
    T m_Data;
    CNode* m_Next;
public:
    //constructor
    CNode (const T &  val = T(), CNode* ptr = nullptr);
    //destructor
    ~CNode ();

    //getter / setter
    const T &GetData () const;
    CNode* GetNextNode () const;
    void SetData (const T & val);
    void SetNextNode (CNode*);
};


template <typename T>
CNode<T>::CNode (const T & val, CNode* ptr ) : m_Data (val), m_Next (ptr)
{
}

template <typename T>
CNode<T>::~CNode ()
{
    delete m_Next;
    //cout << m_Data << endl;
}

template <typename T>
const T & CNode<T>::GetData () const
{
    return m_Data;
}

template <typename T>
CNode<T>* CNode<T>::GetNextNode () const
{
    return m_Next;
}


template <typename T>
void CNode<T>::SetData (const T & val)
{
    m_Data = val;
}

template <typename T>
void CNode<T>::SetNextNode (CNode* ANode)
{
    m_Next = ANode;
}

#endif // NODE_HPP
